Index: src/Shapes/Makefile.am
===================================================================
--- src/Shapes/Makefile.am	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/Shapes/Makefile.am	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -13,7 +13,7 @@
   Shapes/ShapeExceptions.hpp \
   Shapes/ShapeOps.hpp \
-  Shapes/ShapeOps_impl.hpp
+  Shapes/ShapeOps_impl.hpp \
+  Shapes/ShapeType.hpp
 
-  
 
 noinst_LTLIBRARIES += libMolecuilderShapes.la
Index: src/Shapes/Shape.cpp
===================================================================
--- src/Shapes/Shape.cpp	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/Shapes/Shape.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -26,5 +26,11 @@
 #include "Shapes/Shape_impl.hpp"
 #include "Shapes/ShapeExceptions.hpp"
-
+#include "Shapes/ShapeType.hpp"
+
+#include "Tesselation/ApproximateShapeArea.hpp"
+#include "Tesselation/ApproximateShapeVolume.hpp"
+
+#include <algorithm>
+#include <limits>
 #include <string>
 
@@ -48,5 +54,53 @@
 }
 
-LineSegmentSet Shape::getLineIntersections(const Line &line){
+Vector Shape::getCenter() const{
+  return impl->getCenter();
+}
+
+double Shape::getRadius() const{
+  return impl->getRadius();
+}
+
+/** Returns the volume of the Shape.
+ *
+ * If the underlying implementation does not have a working implementation,
+ * i.e. returns -1., then we use an approximate method to calculate the
+ * volume via a mesh of grid points and checking for isInside (basically
+ * a Monte-Carlo integration of the volume).
+ *
+ * \return volume of the shape
+ */
+double Shape::getVolume() const
+{
+	const double volume = impl->getVolume();
+	if (volume  != -1.) {
+		return volume;
+	} else {
+		ApproximateShapeVolume Approximator(*this);
+		return Approximator();
+	}
+}
+
+/** Returns the surface area of the Shape.
+ *
+ * If the underlying implementation does not have a working implementation,
+ * i.e. returns -1., then we use the working filling of the shapes surface
+ * with points and subsequent tesselation and obtaining the approximate
+ * surface area therefrom.
+ *
+ * @return surface area of the Shape
+ */
+double Shape::getSurfaceArea() const
+{
+	const double surfacearea = impl->getSurfaceArea();
+	if (surfacearea != -1.) {
+		return surfacearea;
+	} else {
+		ApproximateShapeArea Approximator(*this);
+		return Approximator();
+	}
+}
+
+LineSegmentSet Shape::getLineIntersections(const Line &line) const{
   return impl->getLineIntersections(line);
 }
@@ -54,4 +108,8 @@
 std::vector<Vector> Shape::getHomogeneousPointsOnSurface(const size_t N) const {
   return impl->getHomogeneousPointsOnSurface(N);
+}
+
+std::vector<Vector> Shape::getHomogeneousPointsInVolume(const size_t N) const {
+	return impl->getHomogeneousPointsInVolume(N);
 }
 
@@ -67,6 +125,14 @@
 }
 
+bool Shape::operator==(const Shape &rhs) const{
+	return (this->getType() == rhs.getType());
+}
+
 std::string Shape::toString() const{
   return impl->toString();
+}
+
+enum ShapeType Shape::getType() const{
+	return impl->getType();
 }
 
@@ -102,9 +168,9 @@
 AndShape_impl::~AndShape_impl(){}
 
-bool AndShape_impl::isInside(const Vector &point){
+bool AndShape_impl::isInside(const Vector &point) const{
   return lhs->isInside(point) && rhs->isInside(point);
 }
 
-bool AndShape_impl::isOnSurface(const Vector &point){
+bool AndShape_impl::isOnSurface(const Vector &point) const{
   // check the number of surfaces that this point is on
   int surfaces =0;
@@ -138,5 +204,5 @@
 }
 
-Vector AndShape_impl::getNormal(const Vector &point) throw (NotOnSurfaceException){
+Vector AndShape_impl::getNormal(const Vector &point) const throw (NotOnSurfaceException){
   Vector res;
   if(!isOnSurface(point)){
@@ -149,10 +215,46 @@
 }
 
-LineSegmentSet AndShape_impl::getLineIntersections(const Line &line){
+Vector AndShape_impl::getCenter() const
+{
+  // calculate closest position on sphere surface to other center ..
+  const Vector rhsDistance = rhs->getCenter() + rhs->getRadius()*((lhs->getCenter() - rhs->getCenter()).getNormalized());
+  const Vector lhsDistance = lhs->getCenter() + lhs->getRadius()*((rhs->getCenter() - lhs->getCenter()).getNormalized());
+  // .. and then it's right in between those two
+  return 0.5*(rhsDistance + lhsDistance);
+}
+
+double AndShape_impl::getRadius() const
+{
+  const double distance = (lhs->getCenter() - rhs->getCenter()).Norm();
+  const double minradii = std::min(lhs->getRadius(), rhs->getRadius());
+  // if no intersection
+  if (distance > (lhs->getRadius() + rhs->getRadius()))
+    return 0.;
+  else // if intersection it can only be the smaller one
+    return minradii;
+}
+
+double AndShape_impl::getVolume() const
+{
+	// TODO
+	return -1.;
+}
+
+double AndShape_impl::getSurfaceArea() const
+{
+	// TODO
+	return -1.;
+}
+
+LineSegmentSet AndShape_impl::getLineIntersections(const Line &line) const{
   return intersect(lhs->getLineIntersections(line),rhs->getLineIntersections(line));
 }
 
-std::string AndShape_impl::toString() {
+std::string AndShape_impl::toString() const{
   return std::string("(") + lhs->toString() + std::string("&&") + rhs->toString() + std::string(")");
+}
+
+enum ShapeType AndShape_impl::getType() const{
+	return CombinedType;
 }
 
@@ -174,4 +276,10 @@
 }
 
+std::vector<Vector> AndShape_impl::getHomogeneousPointsInVolume(const size_t N) const {
+	ASSERT(0,
+			"AndShape_impl::getHomogeneousPointsInVolume() - not implemented.");
+	return std::vector<Vector>();
+}
+
 
 Shape operator&&(const Shape &lhs,const Shape &rhs){
@@ -188,9 +296,9 @@
 OrShape_impl::~OrShape_impl(){}
 
-bool OrShape_impl::isInside(const Vector &point){
+bool OrShape_impl::isInside(const Vector &point) const{
   return rhs->isInside(point) || lhs->isInside(point);
 }
 
-bool OrShape_impl::isOnSurface(const Vector &point){
+bool OrShape_impl::isOnSurface(const Vector &point) const{
   // check the number of surfaces that this point is on
   int surfaces =0;
@@ -224,5 +332,5 @@
 }
 
-Vector OrShape_impl::getNormal(const Vector &point) throw (NotOnSurfaceException){
+Vector OrShape_impl::getNormal(const Vector &point) const throw (NotOnSurfaceException){
   Vector res;
   if(!isOnSurface(point)){
@@ -235,10 +343,42 @@
 }
 
-LineSegmentSet OrShape_impl::getLineIntersections(const Line &line){
+Vector OrShape_impl::getCenter() const
+{
+  // calculate furthest position on sphere surface to other center ..
+  const Vector rhsDistance = rhs->getCenter() + rhs->getRadius()*((rhs->getCenter() - lhs->getCenter()).getNormalized());
+  const Vector lhsDistance = lhs->getCenter() + lhs->getRadius()*((lhs->getCenter() - rhs->getCenter()).getNormalized());
+  // .. and then it's right in between those two
+  return .5*(rhsDistance + lhsDistance);
+}
+
+double OrShape_impl::getRadius() const
+{
+  const Vector rhsDistance = rhs->getCenter() + rhs->getRadius()*((rhs->getCenter() - lhs->getCenter()).getNormalized());
+  const Vector lhsDistance = lhs->getCenter() + lhs->getRadius()*((lhs->getCenter() - rhs->getCenter()).getNormalized());
+  return .5*(rhsDistance - lhsDistance).Norm();
+}
+
+double OrShape_impl::getVolume() const
+{
+	// TODO
+	return -1.;
+}
+
+double OrShape_impl::getSurfaceArea() const
+{
+	// TODO
+	return -1.;
+}
+
+LineSegmentSet OrShape_impl::getLineIntersections(const Line &line) const{
   return merge(lhs->getLineIntersections(line),rhs->getLineIntersections(line));
 }
 
-std::string OrShape_impl::toString() {
+std::string OrShape_impl::toString() const{
   return std::string("(") + lhs->toString() + std::string("||") + rhs->toString() + std::string(")");
+}
+
+enum ShapeType OrShape_impl::getType() const{
+	return CombinedType;
 }
 
@@ -260,4 +400,10 @@
 }
 
+std::vector<Vector> OrShape_impl::getHomogeneousPointsInVolume(const size_t N) const {
+	ASSERT(0,
+			"OrShape_impl::getHomogeneousPointsInVolume() - not implemented.");
+	return std::vector<Vector>();
+}
+
 Shape operator||(const Shape &lhs,const Shape &rhs){
   Shape::impl_ptr newImpl = Shape::impl_ptr(new OrShape_impl(getShapeImpl(lhs),getShapeImpl(rhs)));
@@ -273,22 +419,48 @@
 NotShape_impl::~NotShape_impl(){}
 
-bool NotShape_impl::isInside(const Vector &point){
+bool NotShape_impl::isInside(const Vector &point) const{
   return !arg->isInside(point);
 }
 
-bool NotShape_impl::isOnSurface(const Vector &point){
+bool NotShape_impl::isOnSurface(const Vector &point) const{
   return arg->isOnSurface(point);
 }
 
-Vector NotShape_impl::getNormal(const Vector &point) throw(NotOnSurfaceException){
+Vector NotShape_impl::getNormal(const Vector &point) const throw(NotOnSurfaceException){
   return -1.*arg->getNormal(point);
 }
 
-LineSegmentSet NotShape_impl::getLineIntersections(const Line &line){
+Vector NotShape_impl::getCenter() const
+{
+  return arg->getCenter();
+}
+
+double NotShape_impl::getRadius() const
+{
+  return std::numeric_limits<double>::infinity();
+}
+
+double NotShape_impl::getVolume() const
+{
+	// TODO
+	return -1.; //-arg->getVolume();
+}
+
+double NotShape_impl::getSurfaceArea() const
+{
+	// TODO
+	return -1.; // -arg->getSurfaceArea();
+}
+
+LineSegmentSet NotShape_impl::getLineIntersections(const Line &line) const{
   return invert(arg->getLineIntersections(line));
 }
 
-std::string NotShape_impl::toString(){
+std::string NotShape_impl::toString() const{
   return std::string("!") + arg->toString();
+}
+
+enum ShapeType NotShape_impl::getType() const{
+	return CombinedType;
 }
 
@@ -296,4 +468,10 @@
   // surfaces are the same, only normal direction is different
   return arg->getHomogeneousPointsOnSurface(N);
+}
+
+std::vector<Vector> NotShape_impl::getHomogeneousPointsInVolume(const size_t N) const {
+	ASSERT(0,
+			"NotShape_impl::getHomogeneousPointsInVolume() - not implemented.");
+	return std::vector<Vector>();
 }
 
Index: src/Shapes/Shape.hpp
===================================================================
--- src/Shapes/Shape.hpp	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/Shapes/Shape.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -19,4 +19,5 @@
 
 #include "Shapes/ShapeExceptions.hpp"
+#include "Shapes/ShapeType.hpp"
 
 #include <vector>
@@ -41,10 +42,20 @@
   Vector getNormal(const Vector &point) const throw(NotOnSurfaceException);
 
-  LineSegmentSet getLineIntersections(const Line&);
+  Vector getCenter() const;
+  double getRadius() const;
+  double getVolume() const;
+  double getSurfaceArea() const;
+
+  LineSegmentSet getLineIntersections(const Line&) const;
   std::vector<Vector> getHomogeneousPointsOnSurface(const size_t N) const;
+  std::vector<Vector> getHomogeneousPointsInVolume(const size_t N) const;
 
   Shape &operator=(const Shape& rhs);
 
+  bool operator==(const Shape &rhs) const;
+
   std::string toString() const;
+  enum ShapeType getType() const;
+
 protected:
   impl_ptr getImpl() const;
Index: src/Shapes/ShapeOps.cpp
===================================================================
--- src/Shapes/ShapeOps.cpp	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/Shapes/ShapeOps.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -20,4 +20,7 @@
 #include "CodePatterns/MemDebug.hpp"
 
+#include <algorithm>
+#include <boost/bind.hpp>
+
 #include "Shapes/ShapeExceptions.hpp"
 #include "Shapes/ShapeOps.hpp"
@@ -34,13 +37,13 @@
 ShapeOpsBase_impl::~ShapeOpsBase_impl(){}
 
-bool ShapeOpsBase_impl::isInside(const Vector &point){
+bool ShapeOpsBase_impl::isInside(const Vector &point) const{
   return arg->isInside(translateIn(point));
 }
 
-bool ShapeOpsBase_impl::isOnSurface(const Vector &point){
+bool ShapeOpsBase_impl::isOnSurface(const Vector &point) const{
   return arg->isOnSurface(translateIn(point));
 }
 
-Vector ShapeOpsBase_impl::getNormal(const Vector &point) throw (NotOnSurfaceException){
+Vector ShapeOpsBase_impl::getNormal(const Vector &point) const throw (NotOnSurfaceException){
   Vector helper = translateIn(point);
   if(!arg->isOnSurface(helper)){
@@ -52,5 +55,16 @@
 }
 
-LineSegmentSet ShapeOpsBase_impl::getLineIntersections(const Line &line){
+Vector ShapeOpsBase_impl::getCenter() const
+{
+  return arg->getCenter();
+}
+
+double ShapeOpsBase_impl::getRadius() const
+{
+  return translateOutPos(Vector(arg->getRadius(), 0., 0.)).Norm();
+}
+
+
+LineSegmentSet ShapeOpsBase_impl::getLineIntersections(const Line &line) const{
   Line newLine(translateIn(line.getOrigin()),translateIn(line.getDirection()));
   LineSegmentSet res(line);
@@ -71,6 +85,14 @@
 }
 
+enum ShapeType ShapeOpsBase_impl::getType() const {
+	return getArg()->getType();
+}
+
 std::vector<Vector> ShapeOpsBase_impl::getHomogeneousPointsOnSurface(const size_t N) const {
-  return getArg()->getHomogeneousPointsOnSurface(N);;
+  return getArg()->getHomogeneousPointsOnSurface(N);
+}
+
+std::vector<Vector> ShapeOpsBase_impl::getHomogeneousPointsInVolume(const size_t N) const {
+  return getArg()->getHomogeneousPointsInVolume(N);
 }
 
@@ -89,21 +111,32 @@
 Resize_impl::~Resize_impl(){}
 
-bool Resize_impl::isInside(const Vector& point){
+double Resize_impl::getVolume() const
+{
+	return getArg()->getVolume() * size;
+}
+
+double Resize_impl::getSurfaceArea() const
+{
+	return getArg()->getSurfaceArea() * size;
+}
+
+
+bool Resize_impl::isInside(const Vector& point) const{
   return getArg()->isInside((1/size) * point);
 }
 
-Vector Resize_impl::translateIn(const Vector& point){
+Vector Resize_impl::translateIn(const Vector& point) const{
   return (1/size) * point;
 }
 
-Vector Resize_impl::translateOutPos(const Vector& point){
+Vector Resize_impl::translateOutPos(const Vector& point) const{
   return size * point;
 }
 
-Vector Resize_impl::translateOutNormal(const Vector& point){
+Vector Resize_impl::translateOutNormal(const Vector& point) const{
   return point;
 }
 
-std::string Resize_impl::toString() {
+std::string Resize_impl::toString() const{
   std::stringstream sstr;
   sstr << "resize(" << getArg()->toString() << "," << size << ")";
@@ -113,8 +146,14 @@
 std::vector<Vector> Resize_impl::getHomogeneousPointsOnSurface(const size_t N) const {
   std::vector<Vector> PointsOnSurface = getArg()->getHomogeneousPointsOnSurface(N);
-  for(std::vector<Vector>::iterator iter = PointsOnSurface.begin(); iter != PointsOnSurface.end(); ++iter) {
-    *iter *= size;
-  }
-  return PointsOnSurface;
+  std::for_each(PointsOnSurface.begin(), PointsOnSurface.end(),
+  		boost::bind(&Vector::operator*, _1, size) );
+  return PointsOnSurface;
+}
+
+std::vector<Vector> Resize_impl::getHomogeneousPointsInVolume(const size_t N) const {
+  std::vector<Vector> PointsOnSurface = getArg()->getHomogeneousPointsInVolume(N);
+  std::for_each(PointsOnSurface.begin(), PointsOnSurface.end(),
+  		boost::bind(&Vector::operator*, _1, size) );
+	return std::vector<Vector>();
 }
 
@@ -133,21 +172,41 @@
 Translate_impl::~Translate_impl(){}
 
-bool Translate_impl::isInside(const Vector& point){
+bool Translate_impl::isInside(const Vector& point) const{
   return getArg()->isInside(point-offset);
 }
 
-Vector Translate_impl::translateIn(const Vector& point){
+Vector Translate_impl::getCenter() const
+{
+  return getArg()->getCenter()+offset;
+}
+
+double Translate_impl::getRadius() const
+{
+  return getArg()->getRadius();
+}
+
+double Translate_impl::getVolume() const
+{
+	return getArg()->getVolume();
+}
+
+double Translate_impl::getSurfaceArea() const
+{
+	return getArg()->getSurfaceArea();
+}
+
+Vector Translate_impl::translateIn(const Vector& point) const{
   return point-offset;
 }
 
-Vector Translate_impl::translateOutPos(const Vector& point){
+Vector Translate_impl::translateOutPos(const Vector& point) const{
   return point+offset;
 }
 
-Vector Translate_impl::translateOutNormal(const Vector& point){
+Vector Translate_impl::translateOutNormal(const Vector& point) const{
   return point;
 }
 
-std::string Translate_impl::toString() {
+std::string Translate_impl::toString() const{
   std::stringstream sstr;
   sstr << "translate(" << getArg()->toString() << "," << offset << ")";
@@ -157,7 +216,13 @@
 std::vector<Vector> Translate_impl::getHomogeneousPointsOnSurface(const size_t N) const {
   std::vector<Vector> PointsOnSurface = getArg()->getHomogeneousPointsOnSurface(N);
-  for(std::vector<Vector>::iterator iter = PointsOnSurface.begin(); iter != PointsOnSurface.end(); ++iter) {
-    *iter += offset;
-  }
+  std::for_each(PointsOnSurface.begin(), PointsOnSurface.end(),
+  		boost::bind(&Vector::operator+, _1, offset) );
+  return PointsOnSurface;
+}
+
+std::vector<Vector> Translate_impl::getHomogeneousPointsInVolume(const size_t N) const {
+  std::vector<Vector> PointsOnSurface = getArg()->getHomogeneousPointsInVolume(N);
+  std::for_each(PointsOnSurface.begin(), PointsOnSurface.end(),
+  		boost::bind(&Vector::operator+, _1, offset) );
   return PointsOnSurface;
 }
@@ -173,9 +238,7 @@
   ShapeOpsBase_impl(_arg),factors(_factors)
 {
-  ASSERT(factors[0]>0,"cannot stretch a shape by a negative amount");
-  ASSERT(factors[1]>0,"cannot stretch a shape by a negative amount");
-  ASSERT(factors[2]>0,"cannot stretch a shape by a negative amount");
   for(int i = NDIM;i--;){
-    reciFactors[i] = 1/factors[i];
+    ASSERT(factors[i]>0.,"cannot stretch a shape by a negative amount");
+    reciFactors[i] = 1./factors[i];
   }
 }
@@ -183,5 +246,17 @@
 Stretch_impl::~Stretch_impl(){}
 
-bool Stretch_impl::isInside(const Vector& point){
+double Stretch_impl::getVolume() const
+{
+	// TODO
+	return -1.;
+}
+
+double Stretch_impl::getSurfaceArea() const
+{
+	// TODO
+	return -1.;
+}
+
+bool Stretch_impl::isInside(const Vector& point) const{
   Vector helper=point;
   helper.ScaleAll(reciFactors);
@@ -189,5 +264,5 @@
 }
 
-Vector Stretch_impl::translateIn(const Vector& point){
+Vector Stretch_impl::translateIn(const Vector& point) const{
   Vector helper=point;
   helper.ScaleAll(reciFactors);
@@ -195,5 +270,5 @@
 }
 
-Vector Stretch_impl::translateOutPos(const Vector& point){
+Vector Stretch_impl::translateOutPos(const Vector& point) const{
   Vector helper=point;
   helper.ScaleAll(factors);
@@ -201,5 +276,5 @@
 }
 
-Vector Stretch_impl::translateOutNormal(const Vector& point){
+Vector Stretch_impl::translateOutNormal(const Vector& point) const{
   Vector helper=point;
   // the normalFactors are derived from appearances of the factors
@@ -213,5 +288,5 @@
 }
 
-std::string Stretch_impl::toString() {
+std::string Stretch_impl::toString() const{
   std::stringstream sstr;
   sstr << "stretch(" << getArg()->toString() << "," << factors << ")";
@@ -221,7 +296,13 @@
 std::vector<Vector> Stretch_impl::getHomogeneousPointsOnSurface(const size_t N) const {
   std::vector<Vector> PointsOnSurface = getArg()->getHomogeneousPointsOnSurface(N);
-  for(std::vector<Vector>::iterator iter = PointsOnSurface.begin(); iter != PointsOnSurface.end(); ++iter) {
-    (*iter).ScaleAll(reciFactors);
-  }
+  std::for_each(PointsOnSurface.begin(), PointsOnSurface.end(),
+  		boost::bind( static_cast<void (Vector::*)(const Vector&)>(&Vector::ScaleAll), _1, reciFactors) );
+  return PointsOnSurface;
+}
+
+std::vector<Vector> Stretch_impl::getHomogeneousPointsInVolume(const size_t N) const {
+  std::vector<Vector> PointsOnSurface = getArg()->getHomogeneousPointsInVolume(N);
+  std::for_each(PointsOnSurface.begin(), PointsOnSurface.end(),
+      boost::bind( static_cast<void (Vector::*)(const Vector&)>(&Vector::ScaleAll), _1, reciFactors) );
   return PointsOnSurface;
 }
@@ -242,22 +323,33 @@
 Transform_impl::~Transform_impl(){}
 
-bool Transform_impl::isInside(const Vector& point){
+double Transform_impl::getVolume() const
+{
+	return getArg()->getVolume();
+}
+
+double Transform_impl::getSurfaceArea() const
+{
+	return getArg()->getSurfaceArea();
+}
+
+bool Transform_impl::isInside(const Vector& point) const{
   return getArg()->isInside(transformationInv * point);
 }
 
-Vector Transform_impl::translateIn(const Vector& point){
+Vector Transform_impl::translateIn(const Vector& point) const{
   return transformationInv * point;
 }
 
-Vector Transform_impl::translateOutPos(const Vector& point){
+Vector Transform_impl::translateOutPos(const Vector& point) const{
   return transformation * point;
 }
 
-Vector Transform_impl::translateOutNormal(const Vector& point){
+Vector Transform_impl::translateOutNormal(const Vector& point) const
+{
   RealSpaceMatrix mat = transformation.invert().transpose();
   return mat * point;
 }
 
-std::string Transform_impl::toString() {
+std::string Transform_impl::toString() const{
   std::stringstream sstr;
   sstr << "transform(" << getArg()->toString() << "," << transformation << ")";
@@ -267,7 +359,13 @@
 std::vector<Vector> Transform_impl::getHomogeneousPointsOnSurface(const size_t N) const {
   std::vector<Vector> PointsOnSurface = getArg()->getHomogeneousPointsOnSurface(N);
-  for(std::vector<Vector>::iterator iter = PointsOnSurface.begin(); iter != PointsOnSurface.end(); ++iter) {
-    *iter = transformation * (*iter);
-  }
+  std::transform( PointsOnSurface.begin(), PointsOnSurface.end(), PointsOnSurface.begin(),
+      boost::bind(static_cast<Vector(*)(const RealSpaceMatrix&,const Vector&)>(operator*), transformation, _1));
+  return PointsOnSurface;
+}
+
+std::vector<Vector> Transform_impl::getHomogeneousPointsInVolume(const size_t N) const {
+  std::vector<Vector> PointsOnSurface = getArg()->getHomogeneousPointsInVolume(N);
+  std::transform( PointsOnSurface.begin(), PointsOnSurface.end(), PointsOnSurface.begin(),
+      boost::bind(static_cast<Vector(*)(const RealSpaceMatrix&,const Vector&)>(operator*), transformation, _1));
   return PointsOnSurface;
 }
Index: src/Shapes/ShapeOps_impl.hpp
===================================================================
--- src/Shapes/ShapeOps_impl.hpp	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/Shapes/ShapeOps_impl.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -17,4 +17,5 @@
 #include "Shapes/Shape_impl.hpp"
 #include "Shapes/ShapeExceptions.hpp"
+#include "Shapes/ShapeType.hpp"
 #include "LinearAlgebra/Vector.hpp"
 #include "LinearAlgebra/RealSpaceMatrix.hpp"
@@ -28,13 +29,17 @@
   ShapeOpsBase_impl(const Shape::impl_ptr&);
   virtual ~ShapeOpsBase_impl();
-  virtual bool isInside(const Vector &point);
-  virtual bool isOnSurface(const Vector &point);
-  virtual Vector getNormal(const Vector &point) throw (NotOnSurfaceException);
-  virtual LineSegmentSet getLineIntersections(const Line&);
+  virtual bool isInside(const Vector &point) const;
+  virtual bool isOnSurface(const Vector &point) const;
+  virtual Vector getNormal(const Vector &point) const throw (NotOnSurfaceException);
+  virtual Vector getCenter() const;
+  virtual double getRadius() const;
+  virtual LineSegmentSet getLineIntersections(const Line&) const;
+  virtual enum ShapeType getType() const;
   virtual std::vector<Vector> getHomogeneousPointsOnSurface(const size_t N) const;
+  virtual std::vector<Vector> getHomogeneousPointsInVolume(const size_t N) const;
 protected:
-  virtual Vector translateIn(const Vector &point)=0;
-  virtual Vector translateOutPos(const Vector &point)=0;
-  virtual Vector translateOutNormal(const Vector &point)=0;
+  virtual Vector translateIn(const Vector &point) const=0;
+  virtual Vector translateOutPos(const Vector &point) const=0;
+  virtual Vector translateOutNormal(const Vector &point) const=0;
   Shape::impl_ptr getArg() const;
 private:
@@ -48,10 +53,13 @@
   virtual ~Resize_impl();
 protected:
-  virtual Vector translateIn(const Vector &point);
-  virtual Vector translateOutPos(const Vector &point);
-  virtual Vector translateOutNormal(const Vector &point);
-  virtual std::string toString();
-  virtual bool isInside(const Vector& point);
+  virtual double getVolume() const;
+  virtual double getSurfaceArea() const;
+  virtual Vector translateIn(const Vector &point) const;
+  virtual Vector translateOutPos(const Vector &point) const;
+  virtual Vector translateOutNormal(const Vector &point) const;
+  virtual std::string toString() const;
+  virtual bool isInside(const Vector& point) const;
   virtual std::vector<Vector> getHomogeneousPointsOnSurface(const size_t N) const;
+  virtual std::vector<Vector> getHomogeneousPointsInVolume(const size_t N) const;
 private:
   double size;
@@ -64,10 +72,15 @@
   virtual ~Translate_impl();
 protected:
-  virtual Vector translateIn(const Vector &point);
-  virtual Vector translateOutPos(const Vector &point);
-  virtual Vector translateOutNormal(const Vector &point);
-  virtual std::string toString();
-  virtual bool isInside(const Vector& point);
+  virtual Vector getCenter() const;
+  virtual double getRadius() const;
+  virtual double getVolume() const;
+  virtual double getSurfaceArea() const;
+  virtual Vector translateIn(const Vector &point) const;
+  virtual Vector translateOutPos(const Vector &point) const;
+  virtual Vector translateOutNormal(const Vector &point) const;
+  virtual std::string toString() const;
+  virtual bool isInside(const Vector& point) const;
   virtual std::vector<Vector> getHomogeneousPointsOnSurface(const size_t N) const;
+  virtual std::vector<Vector> getHomogeneousPointsInVolume(const size_t N) const;
 private:
   Vector offset;
@@ -77,13 +90,18 @@
 {
 public:
-  Stretch_impl(const Shape::impl_ptr&, const Vector&);
+
+
+	Stretch_impl(const Shape::impl_ptr&, const Vector&);
   virtual ~Stretch_impl();
 protected:
-  virtual Vector translateIn(const Vector &point);
-  virtual Vector translateOutPos(const Vector &point);
-  virtual Vector translateOutNormal(const Vector &point);
-  virtual std::string toString();
-  virtual bool isInside(const Vector& point);
+  virtual double getVolume() const;
+  virtual double getSurfaceArea() const;
+  virtual Vector translateIn(const Vector &point) const;
+  virtual Vector translateOutPos(const Vector &point) const;
+  virtual Vector translateOutNormal(const Vector &point) const;
+  virtual std::string toString() const;
+  virtual bool isInside(const Vector& point) const;
   virtual std::vector<Vector> getHomogeneousPointsOnSurface(const size_t N) const;
+  virtual std::vector<Vector> getHomogeneousPointsInVolume(const size_t N) const;
 private:
   Vector factors;
@@ -97,10 +115,13 @@
   virtual ~Transform_impl();
 protected:
-  virtual Vector translateIn(const Vector &point);
-  virtual Vector translateOutPos(const Vector &point);
-  virtual Vector translateOutNormal(const Vector &point);
-  virtual std::string toString();
-  virtual bool isInside(const Vector& point);
+  virtual double getVolume() const;
+  virtual double getSurfaceArea() const;
+  virtual Vector translateIn(const Vector &point) const;
+  virtual Vector translateOutPos(const Vector &point) const;
+  virtual Vector translateOutNormal(const Vector &point) const;
+  virtual std::string toString() const;
+  virtual bool isInside(const Vector& point) const;
   virtual std::vector<Vector> getHomogeneousPointsOnSurface(const size_t N) const;
+  virtual std::vector<Vector> getHomogeneousPointsInVolume(const size_t N) const;
 private:
   RealSpaceMatrix transformation;
Index: src/Shapes/ShapeType.hpp
===================================================================
--- src/Shapes/ShapeType.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Shapes/ShapeType.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,27 @@
+/*
+ * ShapeType.hpp
+ *
+ *  Created on: 18.01.2012
+ *      Author: heber
+ */
+
+#ifndef SHAPETYPE_HPP_
+#define SHAPETYPE_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+//!> enumeration of the possible ShapeTypes
+enum ShapeType {
+	NowhereType,
+	EverywhereType,
+	SphereType,
+	CuboidType,
+	PolygonType,
+	CombinedType,
+	MAX_ShapeType
+};
+
+#endif /* SHAPETYPE_HPP_ */
